"""
Autogenerated module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__
"""


async def compatible_subnets_async(hub, ctx, org: str, linked_account_id: str, region: str = None, sddc: str = None, instance_type: str = None, sddc_type: str = None, num_of_hosts: int = None) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.
        linked_account_id(str): The linked connected account identifier.
        region(str, optional): The region of the cloud resources to work in. Defaults to None.
        sddc(str, optional): sddc. Defaults to None.
        instance_type(str, optional): The server instance type to be used. Defaults to None.
        sddc_type(str, optional): The sddc type to be used. (1NODE, SingleAZ, MultiAZ). Defaults to None.
        num_of_hosts(int, optional): The number of hosts. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.compatible_subnets_async(ctx, org=value, linked_account_id=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.compatible_subnets_async org=value, linked_account_id=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/compatible-subnets-async".format(**{"org": org}),
        query_params={"linkedAccountId": linked_account_id, "region": region, "sddc": sddc, "instanceType": instance_type, "sddcType": sddc_type, "numOfHosts": num_of_hosts},
        data={}
    )


async def aws_subnet(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.aws_subnet(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.aws_subnet org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/compatible-subnets-async".format(**{"org": org}),
        query_params={},
        data={}
    )


async def accounts(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.accounts(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.accounts org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link".format(**{"org": org}),
        query_params={},
        data={}
    )


async def aws(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.aws(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.aws org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/aws/resources/servicequotas/requests".format(**{"org": org}),
        query_params={},
        data={}
    )


async def connected_accounts(hub, ctx, org: str, provider: str = None) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.
        provider(str, optional): The cloud provider of the SDDC (AWS or ZeroCloud). Default value is AWS. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.connected_accounts(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.connected_accounts org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/connected-accounts".format(**{"org": org}),
        query_params={"provider": provider},
        data={}
    )


async def sddc_connection(hub, ctx, org: str, sddc: str = None) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.
        sddc(str, optional): sddc. Defaults to None.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.sddc_connection(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.sddc_connection org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="get",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/sddc-connections".format(**{"org": org}),
        query_params={"sddc": sddc},
        data={}
    )


async def map_zones_request(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.map_zones_request(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.map_zones_request org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/map-customer-zones".format(**{"org": org}),
        query_params={},
        data={}
    )


async def compatible_subnets(hub, ctx, org: str) -> None:
    """
    **Autogenerated function**
    
    Args:
        org(str): Organization identifier.

    Returns:
        None

    Examples:
        Call from code:

        .. code-block:: python

            await hub.exec.vmc.account_linking.compatible_subnets(ctx, org=value)

        Call from CLI:

        .. code-block:: bash

            idem exec vmc.account_linking.compatible_subnets org=value
    """

    return await hub.tool.http.session.request(
        ctx,
        method="post",
        path=ctx.acct.endpoint_url + "/orgs/{org}/account-link/compatible-subnets".format(**{"org": org}),
        query_params={},
        data={}
    )

